---
title: Deprecated tools
slug: Tools/Deprecated_tools
tags:
  - Deprecated
  - Tools
---
<p>{{ToolsSidebar}}</p>

<p>Over the course of DevTools development, we have added several experimental panels to try out new ideas. Not all of these have had wide adoption, and due to the cost of maintenance, seldom used panels are eventually removed.</p>

<p>We have created this list of deprecated or removed panels. This page documents the deprecated panels and the bugs that track their removal. Although these panels have been removed, you still have access to the old code, and there are alternative webextensions that you can try to get similar functionality.</p>

<p>When we deprecate a panel, we begin by getting feedback from the community to determine the impact of removing that panel. Once we have decided to remove the panel, we will provide a warning message, and finally, we will remove the panel from the codebase.</p>

<p>You may see a warning message, as in the following image, when trying to activate a deprecated panel:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16546/devTool_settings_deprecated_notice.png" style="border: 1px solid black; display: block; height: 504px; margin: 0px auto; width: 2558px;"></p>

<p><span id="docs-internal-guid-2b4da094-7fff-a275-e630-2200811ec7cd" style="background-color: transparent; color: #000000; font-family: Arial; font-size: 11pt; font-style: normal; font-variant: normal; font-weight: 400; text-decoration: none; vertical-align: baseline; white-space: pre-wrap;">In addition, if you open the panel for one of these tools, you will also see a warning message about its removal.</span></p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16544/deprecated_tool_notice.png" style="border: 1px solid black; display: block; height: 498px; margin: 0px auto; width: 2558px;"></p>

<h2 id="Scratchpad">Scratchpad</h2>

<p>Scratchpad is deprecated as of Firefox 70 ({{bug(1565380)}}), and will be removed as of Firefox 72 ({{bug(1519103)}}).</p>

<h3 id="Description">Description</h3>

<p>Scratchpad provided an environment for experimenting with JavaScript code. You can write, run, and examine the result of code that interacts with the web page.</p>

<p><img alt="Screenshot of the Scratchpad window with a deprecation message" src="https://mdn.mozillademos.org/files/16859/Screen_Shot_2019-08-26_at_08.08.11.png" style="height: 1012px; width: 1282px;"></p>

<h3 id="Alternatives">Alternatives</h3>

<p>In Firefox 71+, you can write multi-line JavaScript code in the Web Console Editor Mode, making it similar to the Scratchpad. The Editor Mode can be triggered clicking on the icon on the right of the console input, or with <kbd>Ctrl + B</kbd> (<kbd>Cmd + B</kbd> on macOS)</p>

<p><img alt="Screenshot of the Webconsole in inline mode, with the editor mode icon displayed on the right of the console input" src="https://mdn.mozillademos.org/files/16944/editor_mode_toggle_icon.png" style="height: 530px; width: 1476px;">When in Editor Mode, the <kbd>Enter</kbd> key adds a new line in the input, and you can evaluate the expression using <kbd>Ctrl + Enter</kbd> (<kbd>Cmd + Enter</kbd> on macOS).</p>

<p><img alt="Screenshot of the Webconsole multiline input, showing an evaluation with a Syntax Error and another, correct one." src="https://mdn.mozillademos.org/files/16860/Screen_Shot_2019-08-26_at_08.18.26.png" style="height: 1166px; width: 1864px;"></p>

<p>When evaluating, the input isn't cleared, which makes it possible to quickly iterrate over a snippet of code.</p>

<p>The results are displayed in the console output, to the right of the input, providing immediate feedback. Unlike in Scratchpad, errors are properly displayed in the output with an expandable stacktrace, making it easier to debug the code you're currently writing.</p>

<p>Starting Firefox 72, you can import a Javascript file content in the console input with <kbd>Ctrl + O</kbd> (<kbd>Cmd + O</kbd> on macOS), as well as saving the console input content to a file using <kbd>Ctrl + S</kbd> (<kbd>Cmd + S</kbd> on macOS).</p>

<h2 id="WebIDE_and_Connect_page">WebIDE and Connect page</h2>

<p>WebIDE was deprecated as of Firefox 69</p>

<p>Disabled as of Firefox 70 ({{bug(1539451)}}).</p>

<p>Removed as of Firefox 71 ({{bug(1539462)}}).</p>

<h3 id="Description_2">Description</h3>

<p>WebIDE allowed you to connect the Firefox Developer Tools to remote browsers, such as Firefox for Android. It was also intended to support application development for Firefox OS.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16613/WebIDE_68.png" style="display: block; height: 632px; margin: 0px auto; width: 600px;"></p>

<h3 id="Alternatives_2">Alternatives</h3>

<p>Remote debugging is available in about:debugging as of Firefox 68. Features not ported to about:debugging are: WiFi debugging for Firefox for Android, application development. Features that are planned but not ported yet: remote browser screenshots and edit remote browser configuration. More details on the <a href="https://groups.google.com/forum/#!topic/mozilla.dev.developer-tools/aWA7JJ-TpRw">mailing-list thread</a>.</p>

<h2 id="Canvas_debugger">Canvas debugger</h2>

<p>Bugzilla issue: {{bug(1403938)}}</p>

<p>Removed as of Firefox 67</p>

<h3 id="Description_3">Description</h3>

<p>Canvas Debugger allowed users to inspect the canvas element and see how frequently a given function is called. It was deprecated due to lack of use.</p>

<p>We do not have dedicated documentation for the Canvas Debugger.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16543/canvas_tool.png" style="display: block; margin: 0 auto; width: 800px;"></p>

<h3 id="Alternatives_3">Alternatives</h3>

<p><a href="https://addons.mozilla.org/en-US/firefox/addon/spector-js/#&amp;gid=1&amp;pid=2" id="docs-internal-guid-836d1256-7fff-1e5e-9c9c-357ae6e43dba" style="text-decoration: none;"><u>Spector.js</u></a><span style="background-color: transparent; color: #000000; font-family: Arial; font-size: 11pt; font-style: normal; font-variant: normal; font-weight: 400; text-decoration: none; vertical-align: baseline; white-space: pre-wrap;"> is a WebExtension that can provide these features with 3D contexts.</span></p>

<h2 id="Web_Audio_editor">Web Audio editor</h2>

<p>Bugzilla issue: {{bug(1403944)}}</p>

<p>Removed as of Firefox 67</p>

<h3 id="Description_4">Description</h3>

<p>The Web Audio Editor allowed you to examine an audio context constructed in the page and provided a visualization of its graph. This gave a high-level view of its operation, and enabled you to ensure that all the nodes are connected in the way you expect. It was possible to edit the AudioParam properties for each node in the graph. Some non-AudioParam properties, like an OscillatorNode's type property, were displayed and editable as well. It was deprecated due to lack of use.</p>

<p>More details about the <a href="/en-US/docs/Tools/Web_Audio_Editor">Web Audio Editor</a></p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16548/webAudio_tool.png" style="border: 1px solid black; display: block; margin: 0 auto; width: 800px;"></p>

<h3 id="Alternatives_4">Alternatives</h3>

<p>Alternatives include <a href="https://github.com/google/audion">AudioN</a> and <a href="https://github.com/spite/WebAudioExtension">https://github.com/spite/WebAudioExtension</a> web extensions.</p>

<h2 id="Shader_editor">Shader editor</h2>

<p>Bugzilla issue: {{bug(1342237)}}</p>

<p>Removed as of Firefox 67</p>

<h3 id="Description_5">Description</h3>

<p>The Shader Editor allowed users to examine and edit the source of the WebGL vertex and fragment shaders. It was deprecated due to low usage and maintenance costs.</p>

<p>More details about the <a href="/en-US/docs/Tools/Shader_Editor">Shader Editor</a></p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16547/shaderEditor_tool.png" style="border: 1px solid black; display: block; margin: 0 auto; width: 800px;"></p>

<h3 id="Alternatives_5">Alternatives</h3>

<p>An alternative to this panel is this extension: <a href="https://github.com/spite/ShaderEditorExtension">https://github.com/spite/ShaderEditorExtension</a>, or <a href="https://addons.mozilla.org/en-US/firefox/addon/spector-js/#&amp;gid=1&amp;pid=2">Spector.js</a> also supports a Shader Editor that requires a library to use a shader reloader hook. Currently only the Babylon library does.</p>
